tween = new Object();

tween.objects = new Array();




tween.interpolate = function(t,type){//is the decimal of completenes in time e.g 0.25 is a 1/4 of time
	switch (type) { 
		case 1 : //linear
			return(t);
			break; 
		case 2 : //decceleration
			return(Math.sin(Math.PI/2*t));
			break; 
		case 3 : //acceleration
			return(t*t);
			break; 
		case 4 : //bouncing
			return(1.3*Math.sin(Math.PI/2*t)+0.3*Math.sin(3*Math.PI/2*t));
			break; 
		case 5 : //easing in and out
			//return(0.4*Math.sin(Math.PI*(t-0.5))+0.6);
			return(0.5*Math.sin(Math.PI*(t-0.5))+0.5);
			break; 
		case 6 : //warming up
			//return(0.4*Math.sin(Math.PI*(t-0.5))+0.6);
			return(0.5*Math.sin(Math.PI*(t-0.5))+0.5 - 0.2 * Math.sin(Math.PI*1.5*t)*(1-t));
			break; 
	 	default : 
			return(t);
	 }
}

tween.render = function(){
	for (var i=1;i<=tween.objects.length;i++){
		var trgt= tween.objects[i-1].trgt;
		var prop = tween.objects[i-1].prop;
		var mov = tween.objects[i-1].val_shift;
		var type = tween.objects[i-1].type;
		
		var t = (getTimer()-tween.objects[i-1].s_time)/tween.objects[i-1].duration;
		out2="time: "+t;
		if (t>=1){
			eval(trgt)[prop]= mov + tween.objects[i-1].val_start;
			tween.objects.splice(i-1,1);
			//i=object_tween.length+1;
		}else{
			eval(trgt)[prop]= (tween.interpolate(t,type)*mov + tween.objects[i-1].val_start);
		}
	}
	
	//output
	out2="objects in tween: "+tween.objects.length+" "+random(2);
	for (var i=1;i<=tween.objects.length;i++){
		
		var trgt= tween.objects[i-1].trgt;
		var prop = tween.objects[i-1].prop;
		var mov = tween.objects[i-1].val_shift;
		var t = (getTimer()-tween.objects[i-1].s_time)/tween.objects[i-1].duration;
		out2+="\n- "+tween.objects[i-1].trgt+"."+tween.objects[i-1].prop+", "+int(t*100)+"%";
	}
}




tween.set = function(obj,val,duration,type){
	if (obj.indexOf(".")<>-1) {
		trgt = obj.slice(0, obj.lastIndexOf("."));
		prop = obj.slice(obj.lastIndexOf(".")+1, obj.length);

		//check if 360 valueOf
		if (prop == "rz" || prop=="_rotation" || prop=="rx"){
			var a = eval(trgt)[prop];
			var b = val;
			
			trace(">a: "+a+", b: "+b);
			a%=360;
			b%=360;
			trace("<a: "+a+", b: "+b);
			
			var t = a;
			if (t<=0){
				a = 360+t;
			}
			var t = b;
			if (t<=0){
				b = 360+t;
			}
			var diff = Math.max(a,b)-Math.min(a,b);
			
			if (Math.min(a,b)+diff >360){
				a+=360;
				b+=360;
			}
			if(b<=45 && a>=270){
				b+=360;
			}
			if(a<=45 && b>=270){
				a+=360;
			}
			/*if (a>180 && b<180){
				b+=360;
			}*/
			/*if (b>180 && a<180){
				b+=360;
				//b+=360;
			}*/

			eval(trgt)[prop]=a;
			val=b;
			
			trace("#a: "+a+", b: "+b+" old diff"+diff);
		}
		
		
		
		//check if already in database
		for (var i=1;i<=tween.objects.length;i++){
			if (tween.objects[i-1].trgt == trgt && tween.objects[i-1].prop == prop){
				tween.objects.splice(i-1,1);
				i=tween.objects.length+1;
			}
		}
		var nr=tween.objects.length;
		
		tween.objects[nr] = new Object();
		tween.objects[nr] = {trgt:trgt,prop:prop,val_start:eval(trgt)[prop],
							val_shift:(Number(val)-eval(trgt)[prop]),s_time:getTimer(),duration:duration};
		
		

							
		if (type==null){
			tween.objects[nr].type = 1;//default type of interpolation
		}else{
			tween.objects[nr].type = type;//type of interpolation
		}

	}
}
